# Nichlineares Gleichungssystem

# Die Funktion berechnet zwei Rueckgabewerte
# - Ergebnisvektor (Funktionswert)
# - Jacobi-Matrix, nur falls benoetigt
function [y, jmf] = f(x)
  y = zeros(2,1);
  y(1) = 10 / (x(1)+x(2)) -1 - sqrt(10 - x(1) - x(2));
  y(2) = 10 / (x(1) + x(2)) - 10 / (5 + x(1) - x(2));
  if nargout > 1
    jmf = zeros(2, 2);
    jmf(1,1) = 1/(2*sqrt(10-x(1)-x(2))) - 10/((x(1)+x(2))^2);;
    jmf(1,2) = 1/(2*sqrt(10-x(1)-x(2))) - 10/((x(1)+x(2))^2);
    jmf(2,1) = 10/((5+x(1)-x(2))^2) - 10/((x(1)+x(2))^2);
    jmf(2,2) = -10/((x(1)+x(2))^2) - 10/((5+x(1)-x(2))^2);
  endif
endfunction

[x, v, info] = fsolve(@f, [0.5; 2.0], optimset("jacobian", "on"));

if (1 == info)
  printf("x = %g\ny = %g\nz = %g\n", x(1), x(2), (10/(x(1)+x(2))));
else
  printf("Leider keine Loesung gefunden!\n")
end

