# Vektor mit den H-Werten
h = [ -525 -470 -420 -330 -220 -120    0 ]';

# Vektor mit den B-Werten
b = [    0 0.50 0.72 0.94 1.12 1.22 1.30 ]';

# Spline-Interpolation
global pp;
pp = interp1(h, b, 'spline', 'pp');

# Erste Ableitung des Splines
global ppd;
ppd = ppder(pp);

function [y, yder] = Bsoll(x)
  global pp;
  global ppd;
  y = ppval(pp, x) - 0.8;
  yder = NA;
  if (nargout > 1)
    yder = ppval(ppd, x);
  endif
endfunction

# Problem 2: Suche nach H für vorgegebenes B=0.8 Tesla
[H2, distance, info] = fsolve(@Bsoll, -250, optimset("jacobian", "on"));
if (1 == info)
  printf('Loesung: H2 = %g\n', H2);
else
  printf('Leider keine Loesung gefunden!\n'); 
endif

