# Vektor mit den H-Werten
h = [ -525 -470 -420 -330 -220 -120    0 ]';

# Vektor mit den B-Werten
b = [    0 0.50 0.72 0.94 1.12 1.22 1.30 ]';

global pp;				# Ergebnis der Spline-Interpolation
pp = interp1(h, b, 'spline', 'pp');
# pp = csape(h, b, 'not-a-knot');
# pp = csape(h, b, 'variational');

global ppd1;				# Erste Ableitung von pp
ppd1 = ppder(pp);

global ppd2;				# Zweite Ableitung von pp
ppd2 = ppder(ppd1);

# Berechnung von B*H.
function [y] = BH(x)
  global pp;
  y = x .* ppval(pp, x);
endfunction

# Erste und zweite Ableitung von B*H
function [y, yder] = BHder(x)
  global pp; global ppd1; global ppd2;
  y = ppval(pp, x) + x .* ppval(ppd1, x);
  yder = NA;
  if (nargout > 1)
    yder = 2 * ppval(ppd1, x) + x * ppval(ppd2, x);
  endif
endfunction

# Problem 3: Suche nach Maximum fuer B*H
[H3, diff, info] = fsolve(@BHder, -250, optimset("jacobian", "on"));
if (1 == info)
  printf('H3 = %g\nB3 = %g\nBH = %g\n', H3, ppval(pp, H3), BH(H3));
else
  printf('Leider keine Loesung fuer Problem 3 gefunden!\n');
end

