// Gegebene Werte
Uamax =  14.32;		// Maximale Ausgangsspannung
Uamin = -12.92;		// Minimale Ausgangsspannung
R1    =   4.71e3;	// R1
Ue    =  13;		// Eingangs-Amplitude
Ks    =   0.73;		// Sollwert fuer Tastverhaeltnis
phis  = -172.0;		// Sollwert fuer Phasenverschiebung

// Funktion, deren Nullstelle gesucht wird 
function y = trigger(x)
    Usmax = (R1 * Uamax + x(1) * x(2))/(R1 + x(1));
    Usmin = (R1 * Uamin + x(1) * x(2))/(R1 + x(1));
    y = [   0.5+(asin(Usmax/Ue)+asin(Usmin/Ue))/(2*%pi)-Ks
            -180*(1-asin(Usmin/Ue)/%pi)-phis ];
endfunction
    
[x,v,info] = fsolve([9.0e3; 10], trigger);
if(1 == info) then
    printf('Loesung\nR2   = %g\nUref = %g\n', x(1), x(2));
else
    printf("Leider keine Loesung gefunden!\n");
end
